<?php
/*
 *
 * pnp4nagios template for check_nfping.
 *
 * use RRD_STORAGE_TYPE = MULTIPLE.
 *
 * Author: Philippe Kueck <projects at unixadm dot org>
 *
 */

$myds = array();
for ($i = 1; $i <= count($DS); $i++) {$myds[$NAME[$i]] = $i;}

// --------- Latency ----------
$i = 0;
$ds_name[$i] = "nfping";
$opt[$i] = " --vertical-label \"rtt\" -b 1000 -E --title \"$hostname / nfping\" ";
$def[$i] = "";

$def[$i] .= rrd::def("lat_min", $RRDFILE[$myds["latency_min"]], $DS[$myds["latency_min"]], "AVERAGE");
$def[$i] .= rrd::def("lat_avg", $RRDFILE[$myds["latency_avg"]], $DS[$myds["latency_avg"]], "AVERAGE");
$def[$i] .= rrd::def("lat_max", $RRDFILE[$myds["latency_max"]], $DS[$myds["latency_max"]], "AVERAGE");

foreach (array_keys($myds) as $ping) {
  switch ($ping) {
    case "packetloss":
    case "latency_min":
    case "latency_avg":
    case "latency_max": continue 2;
  }
  $def[$i] .= rrd::def($ping, $RRDFILE[$myds[$ping]], $DS[$myds[$ping]], "AVERAGE");
  $def[$i] .= rrd::cdef($ping."_st", "$ping,lat_avg,-");
  $def[$i] .= rrd::area("lat_avg", "");
  $def[$i] .= rrd::area($ping."_st", "#40404010", "", 1);
}

$def[$i] .= rrd::line1("lat_min", "#00ff00", "minimum latency");
$def[$i] .= rrd::gprint("lat_min", array("LAST", "MIN"), "%7.2lf %sms");

$def[$i] .= rrd::line1("lat_max", "#ffa0a0", "maximum latency");
$def[$i] .= rrd::gprint("lat_max", array("LAST", "MAX"), "%7.2lf %sms");

$def[$i] .= rrd::line1("lat_avg", "#a0a0ff", "average latency");
$def[$i] .= rrd::gprint("lat_avg", array("LAST", "MAX", "AVERAGE"), "%7.2lf %sms");

if ($WARN[$myds["latency_avg"]] != "")
	$def[$i] .= rrd::hrule($WARN[$myds["latency_avg"]], "#c0c000",
		"Warning at ".$WARN[$myds["latency_avg"]].$UNIT[$myds["latency_avg"]]."\\n");
if ($CRIT[$myds["latency_avg"]] != "")
	$def[$i] .= rrd::hrule($CRIT[$myds["latency_avg"]], "#ff0000",
		"Critical at ".$CRIT[$myds["latency_avg"]].$UNIT[$myds["latency_avg"]]."\\n");

// --------- Loss ----------
$i++;
$ds_name[$i] = "nfping";
$opt[$i] = " --vertical-label \"%\" -l 0 -u 100 --title \"$hostname / nfping\" ";
$def[$i] = "";
$def[$i] .= rrd::def("loss", $RRDFILE[$myds["packetloss"]], $DS[$myds["packetloss"]], "AVERAGE");
$def[$i] .= rrd::gradient("loss", "ff5c00", "ffdc00", "Packets Lost", 20) ;
$def[$i] .= rrd::gprint("loss", array("LAST", "MAX", "AVERAGE"), "%3.0lf%%");
$def[$i] .= rrd::line1("loss", "#000000");
$def[$i] .= rrd::hrule("100", "#000000") ;

if ($WARN[$myds["packetloss"]] != "")
	$def[$i] .= rrd::hrule($WARN[$myds["packetloss"]], "#c0c000",
		"Warning at ".$WARN[$myds["packetloss"]]. "%\\n");
if ($CRIT[$myds["packetloss"]] != "")
	$def[$i] .= rrd::hrule($CRIT[$myds["packetloss"]], "#ff0000",
		"Critical at ".$CRIT[$myds["packetloss"]]. "%\\n");
?>
